﻿namespace SWAD.API.Consts.Enums;

/// <summary>
///     Service errors for controller
/// </summary>
public enum ServiceResult
{
    /// <summary>
    ///     Returns on the successful executed state
    /// </summary>
    Success,

    /// <summary>
    ///     Returns on the unsuccessful executed state
    /// </summary>
    Failure,

    /// <summary>
    ///     Returns on the unsuccessful executed state not by code
    /// </summary>
    NoResponse,

    /// <summary>
    ///     Returns on the unsuccessful executed state by user
    /// </summary>
    BadRequest,
    /// <summary>
    ///     Returns on the unsuccessful executed state by service
    /// </summary>
    NotFound
}