﻿using System.Text.Json.Serialization;

namespace SWAD.API.Models.JsonStructures.MusicAPI.Spotify;

/// <summary>
///     Json Structure for tidal track response
/// </summary>
public class SpotifyTrackResponse
{
    // ReSharper disable NullableWarningSuppressionIsUsed
    [JsonPropertyName("name")] public string Name { get; set; } = null!;

    [JsonPropertyName("artists")] public Artist[] Artists { get; set; } = null!;

    [JsonPropertyName("album")] public Album Albums { get; set; } = null!;

    public class Artist
    {
        [JsonPropertyName("id")] public string Id { get; set; } = null!;

        [JsonPropertyName("name")] public string Name { get; set; } = null!;
    }

    public class Album
    {
        [JsonPropertyName("id")] public string Id { get; set; } = null!;

        [JsonPropertyName("name")] public string Name { get; set; } = null!;
    }
}