﻿using System.Text.Json.Serialization;

// ReSharper disable NullableWarningSuppressionIsUsed

namespace SWAD.API.Models.JsonStructures.MusicAPI.Tidal;

/// <summary>
///     Json Structure for tidal track response
/// </summary>
public class TidalTrackResponse
{
    [JsonPropertyName("data")] public DataObject Data { get; set; } = new();

    public class DataObject
    {
        [JsonPropertyName("attributes")] public AttributesObject Attributes { get; set; } = new();
        [JsonPropertyName("relationships")] public RelationShipsObject RelationShips { get; set; } = new();

    }
    
    public class AttributesObject
    {
        [JsonPropertyName("title")] public string Title { get; set; } = null!;

    }

    public class RelationShipsObject
    {
        [JsonPropertyName("artists")] public ArtistObject Artist { get; set; } = null!;
        [JsonPropertyName("tracks")] public ArtistObject Track { get; set; } = null!;
    }

    public class ArtistObject
    {
        [JsonPropertyName("data")] public List<ArtistDataObject> Data { get; set; } = null!;
    }
    
    public class TrackObject
    {
        [JsonPropertyName("data")] public List<TrackDataObject> Data { get; set; } = null!;
    }

    public class TrackDataObject
    {
        [JsonPropertyName("id")] public string Id { get; set; } = null!;
    }


    public class ArtistDataObject
    {
        [JsonPropertyName("id")] public string Id { get; set; } = null!;
    }
}