using System.Diagnostics;
using System.Reflection;

namespace SWAD.API;

public static class Program
{
    public static void Main(string[] args)
    {
        var builder = WebApplication.CreateBuilder(args);
        Startup.Configure(builder);
        Startup.ConfigureServices(builder.Services);

        var app = builder.Build();
        Startup.ConfigureApplication(app);
        Splash(app.Logger);
        app.Run();
    }

    private static void Splash(ILogger logger)
    {
        var splash = """
                      ____                     ____            _           _    ____ ___ 
                     / ___|_      ____ _ _ __ |  _ \ _   _  __| | ___     / \  |  _ \_ _|
                     \___ \ \ /\ / / _` | '_ \| | | | | | |/ _` |/ _ \   / _ \ | |_) | | 
                      ___) \ V  V / (_| | |_) | |_| | |_| | (_| |  __/_ / ___ \|  __/| | 
                     |____/ \_/\_/ \__,_| .__/|____/ \__,_|\__,_|\___(_)_/   \_\_|  |___|
                                        |_|                                              
                     """;
        logger.LogWarning(splash);
        logger.LogInformation(
            $"Build assembly version: {FileVersionInfo.GetVersionInfo(Assembly.GetExecutingAssembly().Location).FileVersion}");
    }
}